float4x4	g_worldViewProj : WorldViewProjection;
float4x4	g_worldView : WorldView;
float4x4	g_matProj : Projection;
float4		g_CameraPos;
float	g_fPointSize;
float	g_fViewPortH;
float	g_fParticleScatterRatio;	//[0-1]:0ɋ߂Âقǎ
float	g_fTimeScale;

struct VS_OUTPUT_PARTICLEGROUP
{
	float4 position : POSITION;
	float  size : PSIZE;
	float4 color : COLOR0;
};


VS_OUTPUT_PARTICLEGROUP VS_ParticleGroup(
	float4 pos : POSITION0,
	float psize : PSIZE,
	float4 color : COLOR0
)
{
	VS_OUTPUT_PARTICLEGROUP OUT=(VS_OUTPUT_PARTICLEGROUP)0;
	OUT.position=mul(pos, g_worldViewProj);
	float d = 1.0f/(length(mul(pos,g_worldView).xyz));
	OUT.size=psize*(g_matProj._22/g_matProj._11)*d*g_fViewPortH;
	OUT.color=color;

	return OUT;
}

VS_OUTPUT_PARTICLEGROUP VS_ParticleGroup_Build(
	float4 pos : POSITION0,
	float4 random : NORMAL,
	float psize : PSIZE,
	float4 color : COLOR0
)
{
	VS_OUTPUT_PARTICLEGROUP OUT=(VS_OUTPUT_PARTICLEGROUP)0;
	OUT.position=mul(pos+random*g_fParticleScatterRatio, g_worldViewProj);
	float d = 1.0f/(length(mul(pos,g_worldView).xyz));
	OUT.size=psize*(g_matProj._22/g_matProj._11)*d*g_fViewPortH * (1.0f-g_fParticleScatterRatio);
	OUT.color=color;

	return OUT;
}

VS_OUTPUT_PARTICLEGROUP VS_ParticleGroup_Collapse(
	float4 pos : POSITION0,
	float4 random : NORMAL,
	float psize : PSIZE,
	float4 color : COLOR0
)
{
	VS_OUTPUT_PARTICLEGROUP OUT=(VS_OUTPUT_PARTICLEGROUP)0;
	float4 gravity=float4(0.0f,-0.5f*9.81f*(g_fParticleScatterRatio*g_fParticleScatterRatio*2.0f),0.0f,0.0f);
	OUT.position=mul(pos+random*g_fParticleScatterRatio+gravity, g_worldViewProj);
	float d = 1.0f/(length(mul(pos,g_worldView).xyz));
	OUT.size=psize*(g_matProj._22/g_matProj._11)*d*g_fViewPortH * (1.0f-g_fParticleScatterRatio);
	OUT.color=color;

	return OUT;
}

float4 PS_ParticleGroup(VS_OUTPUT_PARTICLEGROUP IN) : COLOR0
{
	return IN.color;
}

technique tech_effect_particlegroup
{
	pass p0
	{
		VertexShader = compile vs_2_0 VS_ParticleGroup();
		PixelShader  = compile ps_2_0 PS_ParticleGroup();
		PointSpriteEnable = true;
	}
}

technique tech_effect_particlegroup_build
{
	pass p0
	{
		VertexShader = compile vs_2_0 VS_ParticleGroup_Build();
		PixelShader  = compile ps_2_0 PS_ParticleGroup();
		PointSpriteEnable = true;
	}
}

technique tech_effect_particlegroup_collapse
{
	pass p0
	{
		VertexShader = compile vs_2_0 VS_ParticleGroup_Collapse();
		PixelShader  = compile ps_2_0 PS_ParticleGroup();
		PointSpriteEnable = true;
	}
}
