float4x4 g_worldViewProj: WORLDVIEWPROJECTION;
texture	g_Texture0;
float4	g_LightDiffuse;
float4	g_LightAmbient;
float4	g_SelfLight;

sampler TextureSampler = sampler_state
{
	Texture = <g_Texture0>;

	AddressU = Wrap;
	AddressV = Wrap;
};

struct VS_OUTPUT_PLATE
{
	float4 position : POSITION;
	float2 texCoord : TEXCOORD0;
	float4 diffuse : COLOR0;
};

VS_OUTPUT_PLATE VS_Plate(
	float4 Pos	: POSITION,
	float2 texCoord:TEXCOORD0,
	float4 diffuse:COLOR0
){
	VS_OUTPUT_PLATE OUT=(VS_OUTPUT_PLATE)0;

	OUT.position = mul(Pos,g_worldViewProj);
	OUT.texCoord = texCoord;
	OUT.diffuse = saturate(diffuse * saturate(g_LightDiffuse + g_SelfLight)+g_LightAmbient);
	OUT.diffuse.a=diffuse.a;

	return OUT;
}


float4 PS_PlateMaterial( VS_OUTPUT_PLATE IN ) : COLOR
{
	return IN.diffuse;
}

float4 PS_PlateTexture( VS_OUTPUT_PLATE IN ) : COLOR
{
	return IN.diffuse * tex2D(TextureSampler, IN.texCoord);
}

technique tech_plate_material
{
	pass p0
	{
		VertexShader = compile vs_2_0 VS_Plate();
		PixelShader  = compile ps_2_0 PS_PlateMaterial();
	}
}

technique tech_plate_texture
{
	pass p0
	{
		VertexShader = compile vs_2_0 VS_Plate();
		PixelShader  = compile ps_2_0 PS_PlateTexture();
	}
}
